#!/bin/bash
rtpriority=$(cat /etc/kona/chrt.conf|grep priority|cut -b10-)
daemon=$(echo $rtpriority|cut -d'|' -f1)
[ "$daemon" = "" ] && daemon="10"
mpd=$(echo $rtpriority|cut -d'|' -f2)
[ "$mpd" = "" ] && mpd="9"
player=$(echo $rtpriority|cut -d'|' -f3)
[ "$player" = "" ] && player="9"
time="$(cat /etc/kona/chrt.conf|grep time|cut -b6-)"
playername="$(cat /etc/kona/chrt.conf|grep player|cut -b8-)"

chrt2 () {
  [ "$2" = "0" ] && return 0
  pg="$1"
  tpri="$2"
  pri=`expr $tpri - 1`
  pid=`pgrep "$pg"`
  if [ "$pid" != "" ] && [ "$(ps -lp $pid|grep -v PRI|grep '80   0')" != "" ]; then
    if [ "$pg" = "jackd" ]; then
      pid=$(ps -efL|grep $pg|cut -b22-26)
    fi
    n="0"
    for i in $pid
    do
      if [ "$pg" = "jackd" ]; then 
        if [ "$n" = "0" ]; then
          chrt -r -p $pri $i
        else  
          if [ "$n" = "1" ] || [ "$n" = "3" ]; then
            chrt -r -p $tpri $i
#          else
#            if [ "$n" = "2" ]; then
#              chrt -f -p $pri $i
#            fi
          fi
        fi
      else
        chrt -r -p $pri $i
      fi
      n=`expr $n + 1`
    done
    return 1
  fi
  return 0
}

if [ "$(systemctl list-unit-files|grep lightdm.service|grep enable)" = "" ] && [ ! -f /etc/kona/hybrid ]; then
  breakflg=0
  while [ true ]
  do
    sleep $time
    chrt2 jackd $daemon
    if [ $? = 1 ]; then
      [ $breakflg = 1 ] && break
      breakflg=1
    fi
    sleep $time
    chrt2 mpd $mpd
    if [ $? = 1 ]; then
      [ $breakflg = 1 ] && break
      breakflg=1
    fi
  done
else
  while [ true ]
  do
    sleep $time
    chrt2 jackd $daemon
    sleep $time
    chrt2 mpd $mpd
    for i in $playername
    do
      sleep $time
      chrt2 $i $player
    done
  done
fi
